#!/bin/sh
#HDD-Check - Dateisystem-extfs3 der Dbox2-Festplatte ueberpruefen

Version=0.2
Name=DrStoned

if [ ! -f /var/etc/.start_ide ]; then
	msgbox title="Fehler" msg="~cIDE-Treiber nicht geladen !~n~c Bitte den IDE-Treiber in den Treiber- und Bootoptionen laden~n~c und die Dbox neu starten. "
	exit;
	fi
if pidof neutrino > /tmp/null; then
		touch /tmp/.neutrino
		else
		t0="~n~n~c~BErfolgt keine Auswahl, so wird das Skript nach 10 Sekunden abgebrochen"
fi
msg()
{
msgbox title="HDD-Check Version "$Version" by "$Name"" size=32 msg="$text" select="Bitte warten" &
}

text="~c Dieses Skript dient dazu, die Festplatte in der DBox ~n~c zu ~uberpr~ufen.~n~n~c Hierbei wird die HDD ungemountet und anschlieend~n~c das Dateisystem mit fsck.ext3 ~uberpr~uft.~n~c Dieser Vorgang dauert ein paar Minuten.~n~n~s~n~c~Y Achtung: Eventuelle Fehler werden automatisch korrigiert~n~c~Y Die Dbox darf whrend des Festplattenchecks~n~c~Y nicht ausgeschaltet oder resettet werden !~n~c~ !!! Sonst droht Datenverlust !!!~n~s~n~n~c Festplattencheck starten?"$t0""

msgbox title="HDD-Check "$Version" by "$Name"" refresh=3 size=28 msg="$text" select="Nein,ja"

if [ $? = "1" ]; then
	if pidof neutrino > /tmp/null; then
	t4="~cVorgang abgebrochen"
	fi
	if [ -e /tmp/.halt ]; then
		t4="~cVorgang abgebrochen,~n~cDbox2 wird ausgeschaltet !"
	fi
	if [ -e /tmp/.reboot ]; then
		t4="~cVorgang abgebrochen,~n~cDbox2 wird neu gestartet !"
	fi
	msgbox title="HDD-Check" refresh=2 size=50 popup="$t4" timeout=3
	exit;
	fi

if [ -e /tmp/.halt ]; then
	t1=ausschalten
	t2=ausgeschaltet
	else
	t1=rebooten
	t2=neu
	t3=gestartet
fi

text="~c~Y!!! HDD-Check, bitte warten !!!~n~s~n~l~G X Festplatte unmounten~n~l O unmounten testen~n~l O Neutrino beenden~n~l O Festplatte ~uberpr~ufen~n~l O mounte Datenpartition nach /hdd~n~l O Dbox2 "$t1"~n~s~n~cDieser Vorgang dauert ein paar Minuten~n~s"
msg
if pidof neutrino > /tmp/null; then
	touch /tmp/.rebootifnotneutrino
fi

# Hier die Programme oder Daemons abschieen, welche noch auf der Festplatte laufen
# z. B. killall woltimerd



# Programme und Deamons abschalten, welche noch auf der Festplatte laufen, beendet
 
umount /hdd
sleep 2

text="~c~Y!!! HDD-Check, bitte warten !!!~n~s~n~l X Festplatte unmounten~n~l~G X unmounten testen~n~l O Neutrino beenden~n~l O Festplatte ~uberpr~ufen~n~l O mounte Datenpartition nach /hdd~n~l O Dbox2 "$t1"~n~s~n~cDieser Vorgang dauert ein paar Minuten~n~s"
msg
sleep 1
if [ -e /hdd/lost+found/ ] ; then
	if pidof neutrino > /tmp/null; then
	t4="~cVorgang abgebrochen"
	fi
	if [ -e /tmp/.halt ]; then
		t4="~cVorgang abgebrochen,~n~cDbox2 wird ausgeschaltet !"
	fi
	if [ -e /tmp/.reboot ]; then
		t4="~cVorgang abgebrochen,~n~cDbox2 wird neu gestartet !"
	fi
	msgbox title="Fehler" refresh=2 size40 popup="~Y~c!!! Die Festplatte konnte nicht ungemountet werden !!!~n~n~c M~oglicherweise l~auft noch ein Programm auf der Festplatte,~n~c das nicht beendet wurde. "~n~n~Y"$t4" timeout=10
	rm /tmp/.rebootifnotneutrino
	killall msgbox
	exit;
	fi


text="~c~Y!!! HDD-Check, bitte warten !!!~n~s~n~l X Festplatte unmounten~n~l X unmounten testen~n~l~G X Neutrino beenden~n~l O Festplatte ~uberpr~ufen~n~l O mounte Datenpartition nach /hdd~n~l O Dbox2 "$t1"~n~s~n~cDieser Vorgang dauert ein paar Minuten~n~s"
msg
	# Alle nicht bentigten Programme und Deamons abschalten
	# Hier knnt Ihr noch weitere Programme und Daemons einfgen, die Ihr vor dem Festplattencheck abschalten wollt.
	# Am besten Ihr kopiert dazu die entsprechenden Zeilen aus /etc/init.d/halt oder aus der start_neutrino
	
	killall start_neutrino
	killall sectionsd
	killall neutrino
	killall nhttpd
	pzapit -kill
	sleep 2

	i=5
	while expr $i != 0 > /dev/null; do
	  if pidof controld > /dev/null; then echo "Waiting for controld (max. $i seconds)"
	  elif pidof timerd > /dev/null; then echo "Waiting for timerd (max. $i seconds)"
	  elif pidof zapit > /dev/null; then echo "Waiting for zapit (max. $i seconds)"
	  else break;
	fi
	i=`expr $i - 1`
	sleep 1
	done
	
	if pidof tuxmaild > /dev/null; then
		killall tuxmaild
		i=5
		while expr $i != 0 > /dev/null; do 
			if [ -e /tmp/tuxmaild.pid ]; then echo "Waiting for tuxmaild (max. $i seconds)"
			else break;
			fi
			i=`expr $i - 1`
			sleep 1 
		done
	fi;
	
	if pidof tuxcald > /dev/null; then
		killall tuxcald
		i=5
		while expr $i != 0 > /dev/null; do 
			if [ -e /tmp/tuxcald.pid ]; then echo "Waiting for tuxcald (max. $i seconds)"
			else break;
			fi
			i=`expr $i - 1`
			sleep 1 
		done
	fi;
	
	# Programme und Deamons abschalten beendet
	
text="~c~Y!!! HDD-Check, bitte warten !!!~n~s~n~l X Festplatte unmounten~n~l X unmounten testen~n~l X Neutrino beenden~n~l~G X Festplatte ~uberpr~ufen~n~l O mounte Datenpartition nach /hdd~n~l O Dbox2 "$t1"~n~s~n~cDieser Vorgang dauert ein paar Minuten~n~s"
msg
fsck.ext3 -fvy /dev/ide/host0/bus0/target0/lun0/part2 > /var/etc/fsck.log ;
echo ~c~YFestplattencheck vom `date "+%d.%m.%Y  %H:%M Uhr"` >> /var/etc/fsck.log ;

text="~c~Y!!! HDD-Check, bitte warten !!!~n~s~n~l X Festplatte unmounten~n~l X unmounten testen~n~l X Neutrino beenden~n~l X Festplatte ~uberpr~ufen~n~l~G X mounte Datenpartition nach /hdd~n~l O Dbox2 "$t1"~n~s~n~cDieser Vorgang dauert ein paar Minuten~n~s"
msg
sleep 1
/bin/mount -t ext3 /dev/ide/host0/bus0/target0/lun0/part2 /hdd ;
sleep 1

text="~c~Y!!! HDD-Check, bitte warten !!!~n~s~n~l X Festplatte unmounten~n~l X unmounten testen~n~l X Neutrino beenden~n~l X Festplatte ~uberpr~ufen~n~l X mounte Datenpartition nach /hdd~n~l~G X Dbox2 "$t1"~n~s~n~cDieser Vorgang dauert ein paar Minuten~n~s"
msg
sleep 1
msgbox title="Ergebnis HDD-Check" refresh=2 size=32 popup="~c~Y !!! Dbox2 wird "$t2" "$t3" !!!~n~n~c Um das Ergebnis nach beim n~achsten Start in Ruhe anzusehen, ~n~c das Skript ~Y HDD-Check - Festplattencheck - Ergebnis anzeigen ~n~c ausf~uhren, um das Ergebnis des Festplattenchecks anzuzeigen. " timeout=10
msgbox title="Ergebnis HDD-Check" refresh=2 size=26 popup=/var/etc/fsck.log timeout=10

if [ -e /tmp/.rebootifnotneutrino ]; then
	/sbin/reboot
	exit;
	fi
		if [ -e /tmp/.reboot ]; then
		/sbin/reboot
		exit;
		fi
			if [ -e /tmp/.halt ]; then
			/sbin/halt
			exit;
			fi
fi

exit